#!/usr/bin/perl

require "./cource.cgi";
umask(000);

$bgcolor = "white";
$title_col = "darkblue";

&parse;

sub parse {
	my(@pairs, $name, $value);
	local($buffer, %FORM);
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
    } 
	else {
        read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    }

    @pairs = split(/&/,$buffer);
    foreach $pair( @pairs ) {
        ($name,$value)=split(/=/,$pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		unless ($name eq 'comments') {
				$value =~ s/<([^>]|\n)*>//g;
		}

        $FORM{$name} = $value;
    }

	&select_action;
}

sub select_action {
	if($FORM{'id'} ne "") {
		$conf_dir = $main_dir;
		$main_dir = "$main_dir/$FORM{'id'}";
		my $act = $FORM{'action'};
		&{$act};
	}
	else { 
		&display;
	}
}

sub read_list {
	open  (LIST, "$main_dir/list.cgi");
	chomp (@list = <LIST>);
	close (LIST);
	
	$title = $list[0];
	shift @list; #  迭 
}

sub view_list {
	local($title, @list);	
	&read_list;
	&head("$title");
	print "<form method=get action=$cgi_url target=\"vote\">\n";
	print "<input type=hidden name=action value=vote>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<div aling=center>\n";
	print "<table border=0 cellpadding=3 cellspacing=0>\n";
	print "<tr><td><img src=$img_url/subject.gif> <font color=$title_col><b>$title</b></font> <a href=$cgi_url?id=$FORM{'id'}&action=admin_ok title=\" \"><font color=$bgcolor></font></a></td></tr>\n";
	my $i = 1;
	foreach (@list) {
		print "<tr><td><input type=radio name=plus_cnt value=$i>$_</td></tr>\n";
		$i++;
	}
	print "<tr><td align=center><input type=image src=$img_url/submit.gif border=0 width=61 height=28 onClick=\"VoteWindows()\" target=\"vote\">";
	print "&nbsp; &nbsp; <a href=\"javascript:newin(300, 450, '$cgi_url?id=$FORM{'id'}&action=result', 'result')\"><img src=$img_url/result.gif border=0 width=61 height=28></a></td></tr>\n";
	print "</table>\n";
	print "</div>\n";
	print "</form>\n";
	&foot;
}

sub vote{
	if($FORM{'plus_cnt'} ne ""){
		#1ð ̳ ߺǥ  Ұ... ^^
		my $cook_name = "VOTE_$FORM{'id'}";
		&get_date;	
		&read_cookie;
		if($COOKIE{$cook_name} ne "$ENV{'REMOTE_ADDR'}$FORM{'id'}$date") {
			open  (CNT, "$main_dir/cnt/$FORM{'plus_cnt'}.cgi");
			my $cnt = <CNT>;
			close (CNT);
			$cnt++;
			&lock;
			open  (PLUS, ">$main_dir/cnt/$FORM{'plus_cnt'}.cgi");
			print PLUS "$cnt";
			close (PLUS);
			&unlock;
			my $ex_year = $year+1;
			print "Set-Cookie: $cook_name=$ENV{'REMOTE_ADDR'}$FORM{'id'}$date; expires=Sunday, 12-Dec-$ex_year 12:12:12 GMT;\r\n";
		}
		else{
			$alert = "alert(\"ߺǥ  ʽϴ...\");";
		}
		&result;
	}
	else{
		&result;
	}
}

sub read_cookie{
    if($ENV{'HTTP_COOKIE'}) {
        my @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
			my($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
        }
	}
}

sub get_date {
    ($hour,$mday,$mon,$year) = (localtime)[2,3,4,5];
	$mon++;	
	$year += 1900;
	$date = $year.$mon.$mday.$hour; 
}

sub result {
	local($title, @list);
	&read_list;
	
	my $x = 1;
	my $max = 0;
	my $total_cnt = 0;

	foreach (@list) {
		open  (MAX, "$main_dir/cnt/$x.cgi");
		my $comp_cnt = <MAX>;
		close (MAX);
		$total_cnt += $comp_cnt;
		$max = ($max > $comp_cnt) ? "$max" : "$comp_cnt"; 
		$x++;
	}

	&head("ǥ  ");
	if($alert){
		print "<script language=javascript>\n";
		print $alert;
		print "</script>\n";
	}
	print "<div aling=center>\n";
	print "<table border=0 cellpadding=3 cellspacing=0>\n";
	print "<tr><td><img src=$img_url/subject.gif> <font color=$title_col><b>$title</b></font></td></tr>\n";
	print "<tr><td><font color=#3E79FF>ǥο [ $total_cnt  ]</font></td></tr>\n";
	
	if($total_cnt == 0) { #0   Ҵɰ  ....
		$total_cnt = 0.1;
		$max = 0.1;
	}
	my $i = 1;
	foreach (@list) {
		my($part_cnt, $rate, $img_length);
		open  (CNT, "$main_dir/cnt/$i.cgi");
		$part_cnt = <CNT>;
		close (CNT);
		$part_cnt = 0 if($part_cnt eq "");
		$rate = sprintf("%.2f", ($part_cnt/$total_cnt)*100);  # ǥ ۼƮ .
		$img_length = ($total_cnt != 0.1) ? ($part_cnt/$max)*117 : 11; # ⺻  127pixel    
		$img_length += 1 if($img_length < 1); #ݽ .... (̰ 0϶  ̹ ũ )
		print "<tr><td>$_</td></tr>\n";
		print "<tr><td><img src=$img_url/$i.gif width=$img_length height=10 alt=\"$part_cnt ($rate %)\"> $part_cnt <font color=gray>($rate %)</font></td></tr>\n";
		$i++;
	}

	print <<__ETC__;
		<tr><td>
		<form method=post action=$cgi_url>
		<input type=hidden name=action value="etc_write">
		<input type=hidden name=id value="$FORM{'id'}">
		<input type=hidden name=page value="$FORM{'page'}">
		<table width=100% cellpadding=0 cellspacing=0 border=0>
		<tr><td><br><input type=text name=etc size=22 maxlength=20  value=" Ÿǰ" onBlur="checkField(this)" onFocus="clearField(this)" style="background-color:#F6F6F6;border:1 solid black"><input type=submit value="" style="background-color:#CCCCCC;border:1 solid #7D7D7D;height:18"></td></tr>
		</table>
		</td></tr>
__ETC__

	if(-e "$main_dir/etc.cgi"){
		open (ETC, "$main_dir/etc.cgi");
		@etc = <ETC>;
		close (ETC);
		chomp(@etc);
		$end_num = @etc;
		@color = ('#FF0000', '#FF0000', '#FF9F47', '#FF9F47', '#009900', '#009900', '#0C2099', '#0C2099', '#991098', '#991098');
		for(0..$end_num-1){
			if($etc[$_] ne ""){
				$gd = $_ + 1;
#				print "<tr><td><a href=$cgi_url?id=$FORM{'id'}&action=etc_del&number=$FORM{'number'}&sun=$_&page=$page&img=$FORM{'img'}$search_opt><img src=$img_url/etc.gif border=0 alt=\"$gd° ǰ ϱ\"></a> <font color=$color[$_]>$etc[$_]</font></td></tr>\n";
				print "<tr><td><a href=$cgi_url?id=$FORM{'id'}&action=etc_del&cnt=$_&page=$FORM{'page'}><img src=$img_url/etc.gif border=0 alt=\"$gd° ǰ ϱ\"></a> <font color=$color[$_]>$etc[$_]</font></td></tr>\n";			
			}
		}
	}
	print "<tr><td align=center><br><a href=$cgi_url?page=$FORM{'page'}><img src=$img_url/backtolist.gif border=0 width=63 height=21></a></td></tr>\n";
	print "</table>\n";
	print "</div>\n";
	&foot;
}

sub etc_del {
	&get_conf;
	&read_cookie;
	if($CONF{'admin_pwd'} eq "$COOKIE{'ADMIN_PWD'}") {
		&remove_etc;
	}
	else{
		&head("ǰ ");
		print <<__HTML__;
			<br><br><br><br>
			<form method=post action=$cgi_url>
			<input type=hidden name=action value=del_ok>
			<input type=hidden name=cnt value=$FORM{'cnt'}>
			<input type=hidden name=page value=$FORM{'page'}>
			<input type=hidden name=id value=$FORM{'id'}>
			<table border=0 cellspcign=0 cellpadding=3>
				<tr><td> ǰ մϴ.</td></tr>
				<tr><td> йȣ ּ.</td></tr>
				<tr><td><input type=password name=admin_pwd size=26></td></tr>
				<tr><td><input type=submit value="        Ȯ              "></td></tr>			
			</table>
			</form>
__HTML__
		
		&foot;
	}
}

sub del_ok {
	&get_conf;
	my $admin_pwd = crypt($FORM{'admin_pwd'}, "sp");
	if($CONF{'admin_pwd'} eq $admin_pwd) {
		print "Set-Cookie: ADMIN_PWD=$admin_pwd;\n"; 
		&remove_etc;
	}
	else {
		&error("pwd");
	}
}

sub remove_etc {
	open (ETC, "$main_dir/etc.cgi");
	@etc = <ETC>;
	close(ETC);
	
	open (ETC_DATA, ">$main_dir/etc.cgi");
	for (0..$#etc) {
		next if($_ eq "$FORM{'cnt'}");
		print ETC_DATA "$etc[$_]";
	}
	close(ETC_DATA);
	&result;
}

sub get_conf {
    open(CONF,"$conf_dir/conf.cgi");
	foreach (<CONF>){
		if (/(\w+)\s*=\s*(.*?)\s*$/){
			$CONF{$1} = $2;
		}
	}
	close(CONF);
}

sub etc_write {
	my(@etc, $new_etc, $etc_num);
	open (ETC_DATA, "$main_dir/etc.cgi");
	@etc = <ETC_DATA>;
	chomp(@etc);
	close (ETC_DATA);

	$new_etc = $FORM{'etc'};

	if($new_etc ne ( "" || " Ÿǰ" )){
		&lock;
		open (ETC, ">$main_dir/etc.cgi");
		print ETC "$new_etc\n";
		for(0..8){
			print ETC "$etc[$_]\n" if($etc[$_] ne ""); 
		}
		close (ETC);
		&unlock;
	}
	&result;
}

sub display {
	my($list_num, $page, @idx, $start, $end);
	$page = ($FORM{'page'}) ? "$FORM{'page'}" : "1";
	$list_num = 10;

	open (IDX, "$main_dir/idx.cgi");
	@idx = <IDX>;
	close(IDX);
	$list_cnt = @idx;
	$total_page = int($list_cnt/$list_num);
	if(($total_page*$list_num) < $list_cnt) {$total_page += 1;}

	$start = ($page - 1)*$list_num;
	$end = $page*$list_num - 1;
	$cnt_data = $list_cnt - $start;
	&head("ǥ Ʈ ");
	print "<br><table border=0 width=260 cellpadding=2 cellspacing=0>";
	print "<tr bgcolor=#345081><td colspan=2><font color=white> ǥ Ʈ </font></td></tr>";
	for ($start..$end) {
		last if($idx[$_] eq "");
		@data = split(/\|/ ,$idx[$_]);
		$cel_color = ($cnt_data%2 == 0) ? "#DCE6FF" : "#EFF7FF";
		print "<tr bgcolor=$cel_color><td align=center><font color=#FF3A9C>$cnt_data.</font></td><td><a href=$cgi_url?id=$data[0]&action=result&page=$page&from=dsp>$data[1]</a></td></tr>";
		$cnt_data--;
	}
	print "<tr><td colspan=2><br>";
	&pagemove("$page","$total_page");
	print "</td></tr>\n";
	print "<table>\n";
	print "<br>&nbsp; <a href=./admin.cgi target=_blank><img src=$img_url/admin.gif border=0></a>";
	&foot;
}

#===================================  ̵ Լ ^.^  
sub pagemove{
	my($page, $total_page) = @_;
	my($search_val) = ($FORM{'action'} eq "search") ? "&action=search&category=$FORM{'category'}&keyword=$FORM{'keyword'}&start_num=$FORM{'start_num'}" : "";
	my ($sel_col, $font_col, $interval, $start, $end, $prev, $next, $next_opt, $first, $last);
	$sel_col = "#81175B";
	$font_col = "#345081";

	print "<div align=center><table border=0 cellpadding=0 cellspacing=0>";
	print "<tr><td align=center class=ver9><font color=$font_col>";
	$interval = 10; 
	$start = (int(($page-1)/$interval))*$interval + 1;
	$end = $start + $interval -1;

	if($total_page <= $end){
		$end = $total_page;
		$next_opt = "no"
	}

	if($start == 1){
		print "[]...";
	}
	else{
		$prev = $start - 1;
		print "[<a href=$cgi_url?page=1$search_val><font color=$font_col>First</font></a>]";
		print "[<a href=$cgi_url?page=$prev$search_val><font color=$font_col></font></a>]...";
	}
	
	for($start..$end){
		if($page eq $_){
			print "[<font color=$sel_col><b>$_</b></font>]";
		}
		else{
			print "[<a href=$cgi_url?page=$_$search_val><font color=$font_col>$_</font></a>]";
		}
	}

	if($next_opt eq "no"){
		print "...[]";
	}
	else{
		$next = $end + 1;
		$last;
		print "...[<a href=$cgi_url?page=$next$search_val><font color=$font_col></font></a>]";
		print "[<a href=$cgi_url?page=$total_page$search_val><font color=$font_col>Last</font></a>]";
	}
	print "</font></td></tr>\n";
	print "</table></div>\n";
}

sub error{
	my $input = shift;
	if($input eq "pwd"){
		$title = "йȣ ";
		$msg = "йȣ ߸Ǿϴ";
	}
	
	&head("$title");
	print "<br><br><br><br><br>\n";
	print "<font color=#FF2F92 size=5>Error!!!</font><br><br>";
	print "$msg<br><br>\n";
	print "ٽѹ Ȯ .<br><br>" unless($input eq "haker");
	print "<a href=\"javascript:history.go(-1)\">{ B A C K }</a><br><br>";
	&foot;
}

sub head { #Ų   ϰ ϱ... ^^
	my ($title);
	$title = $_[0];
	
	print "Content-type: text/html\n\n";
	print "<!---------------------------------------------------------------------------------->\n";
	print "<!--  Program Name - Sepal's SPVOTE v2.0                                        -->\n";
	print "<!--  Programer - Kim se youn (madgf\@hanmail.net, sepal\@spfamily.com)           -->\n";
	print "<!--  Homepage - http://sepal.woorizip.com or http://www.spfamily.com           -->\n";
	print "<!--  Last Modified - 2001.01.03                                                -->\n";
	print "<!--                                                          made in KOREA   -->\n";
	print "<!---------------------------------------------------------------------------------->\n\n";
	print "<html>\n";
    print "<head><title>  $title  </title>\n";
	print <<__SCRIPT__;
		<script language="javascript">
		function clearField(field){
			if (field.value == field.defaultValue) {
				field.value = "";
			}
		}

		function checkField(field){
			if (field.value == "") {
				field.value = field.defaultValue;
			}
		}

		function newin(width,height,url,name) {
			msgWindow=window.open(url,name,'statusbar=no,scrollbars=yes,status=yes,resizable=yes,width='+width+',height='+height)
		}

		function VoteWindows(){
			window.open('','vote','width=300,height=450,resizable=no,scrollbars=yes');
		}
	</script>
__SCRIPT__

	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style type='text/css'>\n";
	print "<!--\n";
	print "A:link {color:#345081;text-decoration:none;}\n";
	print "A:visited {color:#345081;text-decoration:none;}\n";
	print "A:active {color:red;text-decoration:underline;}\n";
	print "A:hover {color:#345081;text-decoration:underline;}\n";
	print ".ver8 {font-family:Verdana,Arial,;font-size:8pt}\n";
	print "p,br,body,td,select,input,form,textarea,option {font-size:9pt;}\n";
	print ".ad{border:1 solid black}\n";
	print ".cont{line-height:140%}\n";
	print "-->\n";
	print "</style>\n";
	print "</head>\n";
	print  "<body bgcolor=$bgcolor>\n";
    print"<center>\n";
 }
###########################################################
sub foot {
	print "<br><form><input type=image src=$img_url/close.gif onclick=\"window.close()\" border=0></form>\n";
	print "</center>\n</body>\n</html>\n";
	exit;
}

sub lock{
	my($lock_file, $lock_sec, $chk_cnt, $sleep_sec);
	
	$lock_file = "locking";
	$lock_sec = 2; #lockŴ ð()
	$chk_cnt = $lock_sec*10;
	$sleep_sec = 0.1;
	
	while ($chk_cnt--){
		if(-e "$main_dir/$lock_file"){
			select (undef,undef,undef,$sleep_sec);
		}
		else{
			open (LOCK,">$main_dir/$lock_file");
			close (LOCK);
			return 1;
		}
	}
	return 0;
}

sub unlock{
	my ($lock_file) = "locking";
	unlink ("$main_dir/$lock_file");
}

exit;